// Climate Framework for Uncertainty, Negotiation and Distribution
// Version 3.3
// (c) David Anthoff and Richard S.J. Tol
// http://www.fund-model.org
namespace Fund.Components.Welfare;

interface

uses Esmf,
     Fund.CommonDimensions;

type
      
  IGlobalWelfareState = public interface
    property prtp: Double read;
    property elasticityofmarginalutility: Double read;    
    property utilitycalibrationadditive: Double read;
    property utilitycalibrationmultiplicative: Double read;  
    
    property population: IParameter1Dimensional<Timestep, double> read;
    property consumption: IParameter1Dimensional<Timestep, double> read;
    
    property welfare: IVariable1Dimensional<Timestep, double> read;
    property marginalwelfare: IVariable1Dimensional<Timestep, double> read;
  end;
  
  IRegionalWelfareState = public interface
    property prtp: Double read;
    property elasticityofmarginalutility: Double read;  
    property utilitycalibrationadditive: Double read;
    property utilitycalibrationmultiplicative: Double read;  
    
    property starttimestep: Timestep read;
    
    property population: IParameter2Dimensional<Timestep, Region, double> read;
    property consumption: IParameter2Dimensional<Timestep, Region, double> read;
    property income: IParameter2Dimensional<Timestep, Region, double> read;   
    property loss: IParameter2Dimensional<Timestep,Region,double>  read;
    property welfareweight: IParameter1Dimensional<Region, double> read;
    
    property cummulativewelfare: IVariable1Dimensional<Timestep, double> read;
    property marginalwelfare: IVariable2Dimensional<Timestep, Region, double> read;
    
    property totalwelfare: Double read write;
  end;
  
implementation

end.