// Climate Framework for Uncertainty, Negotiation and Distribution
// Version 3.3
// (c) David Anthoff and Richard S.J. Tol
// http://www.fund-model.org
using System;
using System.Collections.Generic;
using System.Text;

namespace Esmf
{
    public class VariableWithTimeDimension<T> : IVariable1Dimensional<Timestep, T>, IParameter1Dimensional<Timestep, T>
    {
        private T[] _values;
        private ModelFields _parent;

        public VariableWithTimeDimension(ModelFields parent)
        {
            // TODO Change this to properly find out how many years the model run will have
            _values = new T[350];

            _parent = parent;
        }

        public T this[Timestep index]
        {
            get
            {
                return _values[index.Value];
            }
            set
            {
                _values[index.Value] = value;
            }
        }

        #region IVariable1Dimensional<Timestep,T> Members

        T IVariable1Dimensional<Timestep, T>.this[Timestep index]
        {
            get
            {
                return this[index];
            }
            set
            {
                this[index] = value;
            }
        }

        #endregion

        #region IParameter1Dimensional<Timestep,T> Members

        T IParameter1Dimensional<Timestep, T>.this[Timestep index]
        {
            get
            {
                return this[index];
            }
        }

        IEnumerable<Parameter1DimensionalMember<Timestep, T>> IParameter1Dimensional<Timestep, T>.GetEnumerator()
        {
            for (int i = 0; i < 350; i++)
            {
                yield return new Parameter1DimensionalMember<Timestep, T>(Timestep.FromSimulationYear(i), _values[i], _parent.AttachedDimensions);
            }
        }

        #endregion
    }
}
